; This file is automaticaly generated. Do not edit!

; *** Literal Code ***


(define (token-type-to-arity token)
  (case token
    ((postfix-typeop prefix-typeop postfix-op prefix-op postfix-jct prefix-jct)
     1)
    ((prod-typeop tensor-typeop sum-typeop binding-op add-op mul-op exp-op
      rel-op and-op or-op imp-op pair-op and-jct or-jct tensor-jct imp-jct)
     2)
    (else 0)))

(define (alg-name-to-token-value alg-name)
  (let ((token-type (alg-name-to-token-type alg-name)))
    (case (token-type-to-arity token-type)
      ((0) alg-name)
      ((1) (lambda (x) (make-alg alg-name x)))
      ((2) (lambda (x y) (make-alg alg-name x y)))
      (else (myerror "unexpected arity" token-type)))))

(define (const-to-token-value const)
  (let ((token-type (const-to-token-type const)))
    (case (token-type-to-arity token-type)
      ((0) (make-term-in-const-form const))
      ((1) (lambda (x) 
	     (make-term-in-app-form 
	      (make-term-in-const-form const) x)))
      ((2) (lambda (x y) 
	     (make-term-in-app-form 
	      (make-term-in-app-form 
	       (make-term-in-const-form const) x) y)))
      (else (myerror "unexpected arity" token-type)))))

; added 01-07-14
(define (const-and-token-type-to-token-value const token-type)
  (case (token-type-to-arity token-type)
    ((0) (make-term-in-const-form const))
    ((1) (lambda (x) 
	   (make-term-in-app-form 
	    (make-term-in-const-form const) x)))
    ((2) (lambda (x y) 
	   (make-term-in-app-form 
	    (make-term-in-app-form 
	     (make-term-in-const-form const) x) y)))
    (else (myerror "unexpected arity" token-type))))

(define (token-type-to-precedence token-type)
  (case token-type
    ((binding-op bindterm) 1)
    ((pair-op term) 2)
    ((imp-op impterm) 3)
    ((or-op orterm) 4)
    ((and-op andterm) 5)
    ((rel-op relterm) 6)
    ((add-op addterm) 7)
    ((mul-op multerm) 8)
    ((exp-op expterm) 9)
    ((appterm) 10)
    ((prefix-op preterm) 11)
    ((postfix-op postterm) 12)
    ((const var number rec-op grec-op grecguard-op if-op atomic-term) 13)
    (else (myerror
	   "token-type-to-precendence: token type expected" token-type))))

(define (left-assoc? token-type)
  (memq token-type
	'(add-op addterm mul-op multerm exp-op expterm and-op andterm or-op orterm appterm)))
			    
(define (right-assoc? token-type)
  (memq token-type '(pair-op term imp-op impterm)))

(define (type-var-name-to-type type-var-name)
  (if (eq? (car type-var-name) #f)
      (myerror "Unknown variable name " (cdr type-var-name))
      (car type-var-name)))

(define (type-var-name-to-name type-var-name)
  (cdr type-var-name))

(define (pt string)
  (let ((t (pf string)))
    (if (eq? (car t) 'atom)
	(cadr t)
	(myerror "pt: term expected" t))))

(define (py string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(cadr t)
	(myerror "py: type expected" t))))

(define (pv string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(term-in-var-form-to-var t)
	(myerror "pv: variable expected" t))))

; *** Token Definitions ***
(define token-nrs
  (list 
   (cons '*eoi* 0)
   (cons 'number 1)
   (cons 'var-index 2)
   (cons 'tvar-name 3)
   (cons 'tconst 4)
   (cons 'var-name 5)
   (cons 'const 6)
   (cons 'pvar-name 7)
   (cons 'pvar-op 8)
   (cons 'pred-infix 9)
   (cons 'predconst-name 10)
   (cons 'idpredconst-name 11)
   (cons 'idpredconstscheme-name 12)
   (cons 'idpredconstscheme-name-wit 13)
   (cons 'type-symbol 14)
   (cons 'alg 15)
   (cons 'constscheme 16)
   (cons 'alg-typeop 17)
   (cons 'postfix-typeop 18)
   (cons 'prefix-typeop 19)
   (cons 'prod-typeop 20)
   (cons 'tensor-typeop 21)
   (cons 'sum-typeop 22)
   (cons 'arrow 23)
   (cons 'postfix-op 24)
   (cons 'prefix-op 25)
   (cons 'rec-op 26)
   (cons 'grec-op 27)
   (cons 'grecguard-op 28)
   (cons 'binding-op 29)
   (cons 'add-op 30)
   (cons 'mul-op 31)
   (cons 'exp-op 32)
   (cons 'rel-op 33)
   (cons 'and-op 34)
   (cons 'or-op 35)
   (cons 'imp-op 36)
   (cons 'pair-op 37)
   (cons 'pairscheme-op 38)
   (cons 'cterm-op 39)
   (cons 'if-op 40)
   (cons 'postfix-jct 41)
   (cons 'prefix-jct 42)
   (cons 'and-jct 43)
   (cons 'or-jct 44)
   (cons 'tensor-jct 45)
   (cons 'imp-jct 46)
   (cons 'quantor 47)
   (cons 'dot 48)
   (cons 'hat 49)
   (cons 'underscore 50)
   (cons 'comma 51)
   (cons 'semicolon 52)
   (cons 'prime 53)
   (cons 'hatprime 54)
   (cons 'hatprimeunderscore 55)
   (cons 'hatunderscore 56)
   (cons 'primeunderscore 57)
   (cons 'lpar 58)
   (cons 'rpar 59)
   (cons 'lbracket 60)
   (cons 'rbracket 61)
   (cons 'lcurl 62)
   (cons 'rcurl 63)
   (cons 'undefined-token 64)
   (cons 'string 65)
   (cons 'mpc-mpc 66)
   (cons 'mpc-proof 67)
   (cons 'mpc-classic 68)
   (cons 'mpc-intuitionistic 69)
   (cons 'mpc-end 70)
   (cons 'mpc-load 71)
   (cons 'mpc-include 72)
   (cons 'mpc-scheme 73)
   (cons 'mpc-type 74)
   (cons 'mpc-pred 75)
   (cons 'mpc-algebra 76)
   (cons 'mpc-function 77)
   (cons 'mpc-partial 78)
   (cons 'mpc-rewrite 79)
   (cons 'mpc-syntax 80)
   (cons 'mpc-op 81)
  ))

(define token-defs
  (vector 
 "*eoi*"
 "number"
 "var-index"
 "tvar-name"
 "tconst"
 "var-name"
 "const"
 "pvar-name"
 "pvar-op"
 "pred-infix"
 "predconst-name"
 "idpredconst-name"
 "idpredconstscheme-name"
 "idpredconstscheme-name-wit"
 "type-symbol"
 "alg"
 "constscheme"
 "alg-typeop"
 "postfix-typeop"
 "prefix-typeop"
 "prod-typeop"
 "tensor-typeop"
 "sum-typeop"
 "arrow"
 "postfix-op"
 "prefix-op"
 "rec-op"
 "grec-op"
 "grecguard-op"
 "binding-op"
 "add-op"
 "mul-op"
 "exp-op"
 "rel-op"
 "and-op"
 "or-op"
 "imp-op"
 "pair-op"
 "pairscheme-op"
 "cterm-op"
 "if-op"
 "postfix-jct"
 "prefix-jct"
 "and-jct"
 "or-jct"
 "tensor-jct"
 "imp-jct"
 "quantor"
 "dot"
 "hat"
 "underscore"
 "comma"
 "semicolon"
 "prime"
 "hatprime"
 "hatprimeunderscore"
 "hatunderscore"
 "primeunderscore"
 "lpar"
 "rpar"
 "lbracket"
 "rbracket"
 "lcurl"
 "rcurl"
 "undefined-token"
 "string"
 "mpc-mpc"
 "mpc-proof"
 "mpc-classic"
 "mpc-intuitionistic"
 "mpc-end"
 "mpc-load"
 "mpc-include"
 "mpc-scheme"
 "mpc-type"
 "mpc-pred"
 "mpc-algebra"
 "mpc-function"
 "mpc-partial"
 "mpc-rewrite"
 "mpc-syntax"
 "mpc-op"
  ))

; *** Action Table ***
(define action-table
  '#(
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2) (66 . 1))
     ((default . *error*) (52 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (40 . 64) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 73) (10 . 12) (11 . 11) (12 . 72) (13 . 71) (15 . 10) (16 . 70) (17 . 9) (19 . 8) (25 . 7) (26 . 69) (27 . 68) (28 . 67) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (58 . 82) (60 . 81))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (58 . 63))
     ((default . -122))
     ((default . -34))
     ((default . -34) (2 . 88) (50 . 87))
     ((default . -82))
     ((default . -44) (2 . 97) (49 . 96) (50 . 95) (53 . 94) (54 . 93) (55 . 92) (56 . 91) (57 . 90))
     ((default . -156))
     ((default . -86) (2 . 100) (49 . 99) (50 . 98))
     ((default . -121))
     ((default . -126) (2 . 101))
     ((default . -158))
     ((default . -3))
     ((default . -154))
     ((default . -152) (24 . 102))
     ((default . -150))
     ((default . -148))
     ((default . -146) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . -144) (32 . 105))
     ((default . -142) (31 . 106))
     ((default . -140) (30 . 108) (33 . 107))
     ((default . -138))
     ((default . -136) (34 . 109))
     ((default . -134) (35 . 111) (36 . 110))
     ((default . -132) (37 . 113) (38 . 112))
     ((default . -32) (9 . 115))
     ((default . -120))
     ((default . -119))
     ((default . -117) (18 . 116))
     ((default . -113) (20 . 117))
     ((default . -112) (3 . 18) (4 . 17) (15 . 10) (20 . 118) (58 . 63))
     ((default . -109) (21 . 120))
     ((default . -107) (22 . 121))
     ((default . -105) (23 . 122))
     ((default . -92) (2 . 125) (49 . 124) (50 . 123))
     ((default . -157))
     ((default . -60) (2 . 133) (49 . 132) (50 . 131) (53 . 130) (54 . 129) (55 . 128) (56 . 127) (57 . 126))
     ((default . -34))
     ((default . -34))
     ((default . -31))
     ((default . -30))
     ((default . -27))
     ((default . -25) (41 . 136))
     ((default . -17))
     ((default . -19))
     ((default . -15))
     ((default . -13) (43 . 137))
     ((default . -11))
     ((default . -9) (44 . 139) (45 . 138))
     ((default . -6))
     ((default . -7) (46 . 140))
     ((default . -4))
     ((default . -2))
     ((default . *error*) (0 . 141))
     ((default . -170))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -85) (51 . 146))
     ((default . *error*) (61 . 147))
     ((default . *error*) (1 . 148) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 152) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 155))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -82) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -32) (9 . 115) (59 . 161))
     ((default . -92) (2 . 125) (49 . 124) (50 . 123) (59 . 162))
     ((default . *error*) (59 . 163))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (48 . 164) (58 . 3) (60 . 2))
     ((default . -24))
     ((default . -22))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (48 . 167) (58 . 82) (60 . 81))
     ((default . *error*) (40 . 64))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (16 . 70) (17 . 9) (19 . 8) (25 . 7) (26 . 69) (27 . 68) (28 . 67) (29 . 6) (58 . 82) (60 . 2))
     ((default . -151))
     ((default . -116))
     ((default . -115))
     ((default . -40) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -34) (2 . 171))
     ((default . -34))
     ((default . -36) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -55) (2 . 174))
     ((default . -56) (2 . 175))
     ((default . -59) (2 . 176))
     ((default . -53) (2 . 177))
     ((default . -50) (2 . 178))
     ((default . -49) (2 . 179))
     ((default . -47) (2 . 180))
     ((default . -45))
     ((default . -91) (2 . 181))
     ((default . -89) (2 . 182))
     ((default . -87))
     ((default . -127))
     ((default . -153))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -147))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . -118))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -114))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -97) (2 . 201) (5 . 200))
     ((default . -95) (2 . 202))
     ((default . -93))
     ((default . -71) (2 . 203))
     ((default . -72) (2 . 204))
     ((default . -75) (2 . 205))
     ((default . -68) (2 . 206))
     ((default . -66) (2 . 207))
     ((default . -65) (2 . 208))
     ((default . -63) (2 . 209))
     ((default . -61))
     ((default . -28) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -41) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -26))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . -1) (0 . accept))
     ((default . -169) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2) (62 . 230) (67 . 229) (68 . 228) (69 . 227) (70 . 226) (71 . 225) (72 . 224) (73 . 223) (74 . 222) (75 . 221) (76 . 220) (77 . 219) (78 . 218) (80 . 217) (52 . -185))
     ((default . *error*) (59 . 162))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81) (61 . 242))
     ((default . -166))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 247))
     ((default . -124))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 249))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 251))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 252))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (39 . 253) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 155))
     ((default . *error*) (58 . 256) (59 . 255))
     ((default . -80))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 155) (59 . 258))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 260))
     ((default . -155))
     ((default . -123))
     ((default . -33))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . -23))
     ((default . -21))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . -149))
     ((default . *error*) (59 . 161))
     ((default . -35))
     ((default . -34))
     ((default . -39) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -37) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -54))
     ((default . -57))
     ((default . -58))
     ((default . -52))
     ((default . -51))
     ((default . -48))
     ((default . -46))
     ((default . -90))
     ((default . -88))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (58 . 82) (60 . 81))
     ((default . -145) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 103) (58 . 82) (60 . 81))
     ((default . -143) (32 . 105))
     ((default . -139) (30 . 108))
     ((default . -141) (31 . 106))
     ((default . -137))
     ((default . -133))
     ((default . -135) (34 . 109))
     ((default . -168) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -128))
     ((default . -129))
     ((default . -29))
     ((default . -111))
     ((default . -110))
     ((default . -108))
     ((default . -106))
     ((default . -104))
     ((default . -98) (2 . 266) (49 . 265) (50 . 264))
     ((default . -96))
     ((default . -94))
     ((default . -70))
     ((default . -73))
     ((default . -74))
     ((default . -69))
     ((default . -67))
     ((default . -64))
     ((default . -62))
     ((default . -16))
     ((default . -18))
     ((default . -10))
     ((default . -8))
     ((default . -14))
     ((default . -12) (43 . 137))
     ((default . -5))
     ((default . *error*) (24 . 276) (25 . 275) (30 . 274) (31 . 273) (33 . 272) (34 . 271) (35 . 270) (36 . 269) (37 . 268) (64 . 267))
     ((default . *error*) (77 . 278))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (64 . 280))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (48 . 282) (58 . 63))
     ((default . *error*) (48 . 284))
     ((default . *error*) (65 . 285))
     ((default . *error*) (65 . 286))
     ((default . *error*) (65 . 287))
     ((default . -184))
     ((default . *error*) (67 . 288))
     ((default . *error*) (67 . 289))
     ((default . -181))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (52 . 292))
     ((default . -200) (62 . 293))
     ((default . *error*) (62 . 295))
     ((default . *error*) (52 . 296))
     ((default . -175))
     ((default . *error*) (48 . 297))
     ((default . *error*) (52 . 298))
     ((default . *error*) (52 . 299))
     ((default . -171))
     ((default . -92) (2 . 125) (49 . 124) (50 . 123) (48 . 300))
     ((default . -186) (48 . -187))
     ((default . -165))
     ((default . -167))
     ((default . -84))
     ((default . -131))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 301))
     ((default . -162))
     ((default . -125))
     ((default . -161))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 302))
     ((default . -159))
     ((default . -164))
     ((default . *error*) (58 . 303))
     ((default . *error*) (58 . 256) (59 . 304))
     ((default . -42))
     ((default . *error*) (39 . 253))
     ((default . -81))
     ((default . -77))
     ((default . *error*) (58 . 256) (59 . 305))
     ((default . -83))
     ((default . -20))
     ((default . -130))
     ((default . -38) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (58 . 82) (60 . 81))
     ((default . -103) (2 . 306))
     ((default . -101) (2 . 307))
     ((default . -99))
     ((default . -218))
     ((default . -219))
     ((default . -220))
     ((default . -221))
     ((default . -222))
     ((default . -223))
     ((default . -225))
     ((default . -224))
     ((default . -226))
     ((default . -227))
     ((default . *error*) (81 . 308))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (48 . 310))
     ((default . -205) (64 . 280))
     ((default . -204) (1 . 312))
     ((default . *error*) (64 . 280))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (48 . 314) (58 . 63))
     ((default . *error*) (64 . 280))
     ((default . -180))
     ((default . -179))
     ((default . -178))
     ((default . -183))
     ((default . -182))
     ((default . -185) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2) (62 . 230))
     ((default . *error*) (48 . 320))
     ((default . -177))
     ((default . -201))
     ((default . -212))
     ((default . -207) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -176))
     ((default . -173))
     ((default . -174))
     ((default . -172))
     ((default . *error*) (64 . 280))
     ((default . -163))
     ((default . -160))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 326))
     ((default . -43))
     ((default . -76))
     ((default . -102))
     ((default . -100))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (48 . 329))
     ((default . *error*) (64 . 330))
     ((default . -206))
     ((default . -203))
     ((default . -197))
     ((default . *error*) (64 . 280))
     ((default . -194))
     ((default . -185) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2) (62 . 230) (63 . 332))
     ((default . -191))
     ((default . *error*) (52 . 335))
     ((default . -186))
     ((default . -189))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2) (63 . 337) (79 . 336) (80 . 217))
     ((default . -207) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (63 . 343))
     ((default . *error*) (48 . 344))
     ((default . -195))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (59 . 346))
     ((default . -217))
     ((default . *error*) (64 . 347))
     ((default . *error*) (58 . 348))
     ((default . -196))
     ((default . -188))
     ((default . -192))
     ((default . *error*) (52 . 349))
     ((default . -190))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . -202))
     ((default . *error*) (52 . 351))
     ((default . -213))
     ((default . -199))
     ((default . *error*) (46 . 352))
     ((default . -208))
     ((default . -198))
     ((default . *error*) (64 . 353))
     ((default . *error*) (59 . 354))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (42 . 5) (47 . 4) (58 . 3) (60 . 2))
     ((default . *error*) (58 . 356))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . -193))
     ((default . *error*) (46 . 358))
     ((default . -214))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (52 . 360))
     ((default . -79))
     ((default . *error*) (59 . 361))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 363))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (29 . 6) (58 . 82) (60 . 2))
     ((default . *error*) (52 . 365))
     ((default . -209))
     ((default . -78))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (58 . 63) (59 . 366))
     ((default . -210))
     ((default . *error*) (52 . 367))
     ((default . -215))
     ((default . -211))
     ((default . -216))
    ))

; *** Goto Table ***
(define goto-table
  '#(
     ((49 . 20)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 60)(1 . 61))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 66))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 74)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 75)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 76))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 77))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 78)(10 . 79))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 80))
     ((46 . 21)(45 . 22)(44 . 83)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 84))
     ((33 . 34)(31 . 85))
     ()
     ((14 . 86))
     ((14 . 89))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 104)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ((48 . 114))
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 119))
     ()
     ()
     ()
     ()
     ()
     ()
     ((14 . 134))
     ((14 . 135))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((50 . 142))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 143))
     ((47 . 144)(46 . 145)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ((33 . 34)(32 . 149)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(32 . 151)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(32 . 153)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(32 . 154)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(32 . 156)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150)(20 . 157)(19 . 158))
     ((33 . 34)(32 . 159)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(32 . 160)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 165)(10 . 166))
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 168)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 169)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 75)(23 . 43))
     ()
     ()
     ()
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((14 . 172))
     ((14 . 173))
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 183))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 184)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 185)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 186)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 187)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 188)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 189)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 190)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(32 . 191)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 192)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 193)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 194)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 195))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 196))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 197))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 198))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 199))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 210)(10 . 211))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 212)(4 . 213))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 214)(8 . 215))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 216))
     ()
     ((68 . 231)(65 . 232)(61 . 233)(58 . 234)(55 . 235)(54 . 236)(53 . 237)(52 . 238)(51 . 239)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 240)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 241))
     ()
     ((46 . 243)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 244))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 245)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((33 . 34)(32 . 246)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ((33 . 34)(32 . 250)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 143))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248)(20 . 254)(19 . 158))
     ((19 . 257))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248)(20 . 259)(19 . 158))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 261))
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 262)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((14 . 263))
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 168)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 104)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((69 . 277))
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 279))
     ((62 . 281))
     ((33 . 34)(32 . 283)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((56 . 290)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 291))
     ()
     ((59 . 294))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ()
     ()
     ((19 . 257))
     ()
     ()
     ()
     ()
     ((19 . 257))
     ()
     ()
     ()
     ((46 . 170)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 309))
     ()
     ((62 . 311))
     ()
     ((62 . 313))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ((62 . 315))
     ()
     ()
     ()
     ()
     ()
     ((57 . 316)(55 . 317)(53 . 318)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 319))
     ()
     ()
     ()
     ((66 . 321))
     ((64 . 322)(63 . 323)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 324))
     ()
     ()
     ()
     ()
     ((62 . 325))
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 65)(22 . 327))
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 328)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ((62 . 331))
     ()
     ((55 . 333)(53 . 334)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 319))
     ()
     ()
     ()
     ()
     ((68 . 338)(67 . 339)(60 . 340)(46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 341)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ((64 . 322)(63 . 342)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 324))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 345))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 350)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 33)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43)(21 . 44)(18 . 45)(17 . 46)(16 . 47)(15 . 48)(13 . 49)(12 . 50)(11 . 51)(10 . 52)(9 . 53)(8 . 54)(7 . 55)(6 . 56)(5 . 57)(4 . 58)(3 . 59)(2 . 355))
     ()
     ((33 . 34)(32 . 357)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ()
     ()
     ()
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 359)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((33 . 34)(32 . 362)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 150))
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ((46 . 21)(45 . 22)(44 . 23)(43 . 24)(42 . 25)(41 . 26)(40 . 27)(39 . 28)(38 . 29)(37 . 30)(36 . 31)(35 . 32)(34 . 364)(33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 42)(23 . 43))
     ()
     ()
     ()
     ((33 . 34)(31 . 35)(30 . 36)(29 . 37)(28 . 38)(27 . 39)(26 . 40)(25 . 41)(24 . 248))
     ()
     ()
     ()
     ()
     ()
    ))

; *** Reduction Table ***
(define reduction-table
  (vector
    '()
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (accept $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 2 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 3 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 4 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 4 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 5 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 5 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 6 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 6 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 7 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 7 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 8 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 8 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 9 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 9 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 10 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 10 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 10 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 11 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 11 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 11 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 12 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 12 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 13 goto-table (apply make-predicate-formula (cons $1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table (make-atomic-formula $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 14 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 14 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 15 goto-table (apply $1 (cons -1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons $2 $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 15 goto-table (apply $1 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons -1 $3)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 17 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 17 goto-table ($2 $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) $2 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 $2 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 (quote ())))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 19 goto-table (apply make-cterm (append $4 (list $6))))))
    (lambda (stack sp goto-table)
      (let* (($6 (vector-ref stack (- sp 1)))
             ($5 (vector-ref stack (- sp 3)))
             ($4 (vector-ref stack (- sp 5)))
             ($3 (vector-ref stack (- sp 7)))
             ($2 (vector-ref stack (- sp 9)))
             ($1 (vector-ref stack (- sp 11))))
          (push stack (- sp 12) 19 goto-table (make-cterm $5))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 20 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 20 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 21 goto-table (make-arity))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 21 goto-table (apply make-arity $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 22 goto-table (cons $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 22 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) $2 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 $2 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 $4 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 24 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 24 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 25 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 25 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 26 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 26 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (apply make-alg (cons (alg-form-to-name $1) (append (alg-form-to-types $1) (list $2)))))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (make-alg $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 29 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 29 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 30 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 30 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-tconst $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-alg $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 31 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 32 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 32 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 33 goto-table (make-tvar -1 $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 33 goto-table (make-tvar $2 $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table (apply mk-term-in-abst-form (append $2 (list $4))))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 34 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 35 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 35 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 36 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 36 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 37 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 37 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 38 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 38 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 39 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 39 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 40 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 40 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 41 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 41 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 42 goto-table (make-gen-application $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 42 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 43 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 43 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 44 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 44 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 45 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 46 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-term-in-var-form $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-numeric-term $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 46 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 46 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-const-form (let* ((tvars (const-to-tvars $2)) (subst (make-substitution tvars $3))) (const-substitute $2 subst #f))))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-if-form (car $3) (cdr $3)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 47 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 47 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 48 goto-table (lambda (x y) (make-term-in-app-form (make-term-in-app-form (make-term-in-const-form (let* ((tvars (const-to-tvars $1)) (subst (make-substitution tvars $2))) (const-substitute $1 subst #f))) x) y)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 49 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-load $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-include $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-scheme $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-start #f #f))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #t))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #f))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-stop))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 53 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 53 goto-table (mpc-claim $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 54 goto-table (mpc-assume $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 55 goto-table (mpc-block-stop))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 56 goto-table (mpc-block-start $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-type $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-var $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-pred (apply make-arity $2) $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-pred (make-arity) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-algebra (car $1) (cadr $1) (cddr $1) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 59 goto-table (mpc-function-rules-start))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 60 goto-table (mpc-function-rules-stop))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 61 goto-table (mpc-declare-algebra-header $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 61 goto-table (mpc-declare-algebra-header $2 0))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 62 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 62 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 63 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 63 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 64 goto-table (list $3 $1))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 65 goto-table (mpc-declare-function $4 $6 $2 1))))
    (lambda (stack sp goto-table)
      (let* (($8 (vector-ref stack (- sp 1)))
             ($7 (vector-ref stack (- sp 3)))
             ($6 (vector-ref stack (- sp 5)))
             ($5 (vector-ref stack (- sp 7)))
             ($4 (vector-ref stack (- sp 9)))
             ($3 (vector-ref stack (- sp 11)))
             ($2 (vector-ref stack (- sp 13)))
             ($1 (vector-ref stack (- sp 15))))
          (push stack (- sp 16) 65 goto-table (mpc-declare-function $5 $7 $3 0))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 67 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 67 goto-table (mpc-computation-rule $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 67 goto-table (mpc-rewrite-rule $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 68 goto-table (mpc-declare-syntax $2 (car $3) (cadr $3) (caddr $3) $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
  ))

; *** Parser Definition ***
(define parser
   (make-parser
    action-table
    goto-table
    reduction-table
    token-defs))

; *** Terminals Table ***

(define terminal-table
   `#(
   ()
   ()
   (("excl" 47 . ,(lambda (v k) (apply mk-excl (append v (list k))))))
   (("CONST" 81 . ,(list (quote const) "CONST" 0)))
   (("LOAD" 71)("=>" 23 . ,make-arrow))
   (("GRecGuard" 28 . ,(lambda (l) (make-term-in-const-form (type-info-to-grecguard-const l)))))
   (("cterm" 39))
   (("SYNTAX" 80))
   ()
   ()
   (("lambda" 29 . ,(lambda (varlist kernel) (apply mk-term-in-abst-form (append varlist (list kernel))))))
   (("excu" 47 . ,(lambda (v k) (apply mk-excu (append v (list k))))))
   ()
   ()
   ()
   (("IMPOP" 81 . ,(list (quote imp-op) "IMPOP" 2)))
   ()
   ()
   (("END" 70)("^'" 54))
   ()
   ()
   ()
   ()
   ()
   (("ADDOP" 81 . ,(list (quote add-op) "ADDOP" 2)))
   ()
   (("{" 62))
   (("^'_" 55)("@@" 20 . ,make-star))
   (("}" 63))
   (("OROP" 81 . ,(list (quote or-op) "OROP" 2)))
   ()
   ()
   ()
   (("!" 45 . ,make-tensor))
   ()
   (("MPC" 66))
   ()
   (("CLASSIC" 68))
   (("SCHEME" 73)("&" 43 . ,make-and))
   (("'" 53))
   (("(" 58)("allnc" 47 . ,(lambda (v k) (apply mk-allnc (append v (list k))))))
   ((")" 59))
   (("MULOP" 81 . ,(list (quote mul-op) "MULOP" 2))("REWRITE" 79)("Total" 10 . ,(string-and-arity-to-predconst-parse-function "Total" (make-arity (make-tvar -1 "alpha")))))
   (("PAIROP" 81 . ,(list (quote pair-op) "PAIROP" 2)))
   (("," 51))
   (("atomic" 4 . ,"atomic"))
   (("TYPE" 74)("." 48)("left" 25 . ,make-term-in-lcomp-form))
   ()
   (("PROOF" 67))
   ()
   (("INTUITIONISTIC" 69))
   (("ex" 47 . ,(lambda (v k) (apply mk-ex (append v (list k))))))
   ()
   ()
   ()
   ()
   ()
   ()
   (("INCLUDE" 72))
   (("ANDOP" 81 . ,(list (quote and-op) "ANDOP" 2))("FUNCTION" 77)(";" 52))
   (("RELOP" 81 . ,(list (quote rel-op) "RELOP" 2))("PARTIAL" 78)("-->" 46 . ,make-impnc))
   (("if" 40)("=" 33 . ,(lambda (term1 term2) (let ((type1 (term-to-type term1)) (type2 (term-to-type term2))) (mk-term-in-app-form (make-term-in-const-form (finalg-to-=-const (if (equal? type1 type2) type1 (types-lub type1 type2)))) term1 term2)))))
   ()
   ()
   (("@" 37 . ,make-term-in-pair-form))
   (("Pvar" 8))
   (("POSTFIXOP" 81 . ,(list (quote postfix-op) "POSTFIXOP" 1))("ALGEBRA" 76)("existential" 4 . ,"existential")("STotal" 10 . ,(string-and-arity-to-predconst-parse-function "STotal" (make-arity (make-tvar -1 "alpha")))))
   ()
   (("SE" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (sfinalg-to-se-const (term-to-type term))) term))))
   (("E" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (finalg-to-e-const (term-to-type term))) term)))("bot" 7 . ,(cons (make-arity) "bot")))
   (("exnc" 47 . ,(lambda (v k) (apply mk-exnc (append v (list k)))))("Equal" 10 . ,(string-and-arity-to-predconst-parse-function "Equal" (make-arity (make-tvar -1 "alpha") (make-tvar -1 "alpha")))))
   (("Rec" 26 . ,(lambda (l) (make-term-in-const-form (apply type-info-to-rec-const l)))))
   ()
   ()
   (("^_" 56))
   ()
   ()
   (("'_" 57)("GRec" 27 . ,(lambda (l) (make-term-in-const-form (type-info-to-grec-const l))))("prop" 4 . ,"prop"))
   ()
   (("right" 25 . ,make-term-in-rcomp-form))
   ()
   ()
   ()
   ()
   (("PREFIXOP" 81 . ,(list (quote prefix-op) "PREFIXOP" 1)))
   ()
   (("->" 46 . ,make-imp))
   ()
   (("exca" 47 . ,(lambda (v k) (apply mk-exca (append v (list k)))))("all" 47 . ,(lambda (v k) (apply mk-all (append v (list k))))))
   ()
   (("nulltype" 4 . ,"nulltype"))
   (("[" 60))
   ()
   (("]" 61))
   (("^" 49))
   (("_" 50)("alpha" 3 . ,"alpha"))
   (("PRED" 75))
  ))

; *** Lexer Definition ***
(define lexer
   (make-lexer
    terminal-table
    token-nrs
))


; *** Shortcut Definition ***
(define (pf string)
   (parser (lexer (string-reader string)) myerror))


(define (parse-file filename)
  (let ((parse-port
    (lambda (port)
      (parser (lexer (port-reader filename port)) myerror))))
    (call-with-input-file filename parse-port)))


; *** Add-Token Definition ***
(define add-token
   (make-add-token
    terminal-table
    token-nrs
))

; *** Remove-Token Definition ***
(define remove-token
   (make-remove-token
    terminal-table
    token-nrs
))

; *** Is-Token? Definition ***
(define is-token?
   (make-is-token?
    terminal-table
    token-defs
))

; *** Display-Tokens Definition ***
(define (display-tokens)
   (lexer-info
    terminal-table
    token-nrs
))

